-------------------------------------------------------------------------------------
-- This sql script is to be run where there are WtDbExceptions / errors in BioUtility
-- This scripts removes duplicate entries.
-- Normally for a given badge there should be only one record matching a finger_index
-- if there are multiple records for the same badge number that have the same finger_index this will cause an error
-- this script fixes this.
-- related cases: KB 92692
-- created 12/08/2010 CT
-------------------------------------------------------------------------------------

-- Backup the database first 
DECLARE @backup as VARCHAR(255)
SELECT @backup = 'WaspTime_' + REPLACE(CONVERT(VARCHAR(24), GETDATE(), 113), ':','') + '.bkp'
BACKUP DATABASE [WaspTime] TO  DISK = @backup WITH  INIT ,  NOUNLOAD ,  NAME = N'Wasptime6 Backup',  NOSKIP ,  STATS = 10,  NOFORMAT
GO

Use [WaspTime]
GO

DECLARE 
@fetch_badge_no numeric(18,0),
@fp_id int,
@finger_index int,
@fp_id_first int,
@recCount int

DECLARE data_cur CURSOR FOR
	SELECT distinct dbo.bioscan_fingerprints.badge_no FROM dbo.bioscan_fingerprints      		      		
    
	open data_cur			

	-- Fetch the first one
    FETCH data_cur INTO @fetch_badge_no
    if (@@fetch_status<>0) 
    GOTO close_procedure  

WHILE (1=1)
BEGIN	

	--for each badge match the existing fingerprint records for this badge. 
	declare data_cur2 CURSOR FOR
	select fp_id, finger_index from bioscan_fingerprints where badge_no = @fetch_badge_no order by fp_id asc
	
	open data_cur2

		--fetch the first one
		FETCH data_cur2 INTO @fp_id, @finger_index
		if (@@fetch_status<>0) 
		GOTO close_procedure2  	

		WHILE (1=1)
		BEGIN

			--how many records use this finger_index 	
			select @recCount = COUNT(fp_id) from bioscan_fingerprints where badge_no = @fetch_badge_no and finger_index = @finger_index

			if (@recCount > 1)
			BEGIN
				
				--delete the duplicated record that has the smallest fp_id.
				select top 1 @fp_id_first = fp_id from bioscan_fingerprints where badge_no = @fetch_badge_no and finger_index = @finger_index order by fp_id asc
				
				--delete from bioscan_fingerprints where badge_no = @fetch_badge_no and fp_id <> @fp_id
				print N'deleting duplicate record';
				print @fetch_badge_no;
				print @fp_id_first

				delete from bioscan_fingerprints where badge_no = @fetch_badge_no and fp_id = @fp_id_first
			END 

			FETCH data_cur2 INTO @fp_id, @finger_index
			if (@@fetch_status<>0) 
			GOTO close_procedure2  	
		END

	close_procedure2:
		print N'close_procedure2';
		close data_cur2	
		deallocate data_cur2

	FETCH data_cur INTO @fetch_badge_no
    if (@@fetch_status<>0) 
    GOTO close_procedure     
END

close_procedure:
	print N'close_procedure';
	close data_cur	
	DEALLOCATE data_cur